<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Installing Prerequisites &mdash; openPASS Documentation</title>
      <link rel="stylesheet" type="text/css" href="../_static/pygments.css?v=b86133f3" />
      <link rel="stylesheet" type="text/css" href="../_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="../_static/css/custom.css?v=4ad39fc2" />
      <link rel="stylesheet" type="text/css" href="../_static/tabs.css?v=a5c4661c" />

  
    <link rel="shortcut icon" href="../_static/openPASS.ico"/>
  <!--[if lt IE 9]>
    <script src="../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../_static/jquery.js?v=5d32c60e"></script>
        <script src="../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="../_static/documentation_options.js?v=6efca38a"></script>
        <script src="../_static/doctools.js?v=888ff710"></script>
        <script src="../_static/sphinx_highlight.js?v=dc90522c"></script>
        <script src="../_static/tabs.js?v=3030b3cb"></script>
    <script src="../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Installing openPASS" href="30_install_openpass.html" />
    <link rel="prev" title="System Requirements" href="15_system_requirements.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../index.html" class="icon icon-home">
            openPASS
              <img src="../_static/openPASS.png" class="logo" alt="Logo"/>
          </a>
              <div class="version">
                1.2.0
              </div>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Installation Guide</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="10_getting_started.html">Getting Started</a></li>
<li class="toctree-l1"><a class="reference internal" href="15_system_requirements.html">System Requirements</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">Installing Prerequisites</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#installing-the-build-environment">Installing the Build Environment</a></li>
<li class="toctree-l2"><a class="reference internal" href="#installing-the-binary-packages">Installing the Binary Packages</a></li>
<li class="toctree-l2"><a class="reference internal" href="#installing-the-dependencies">Installing the Dependencies</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="30_install_openpass.html">Installing openPASS</a></li>
<li class="toctree-l1"><a class="reference internal" href="50_further_guidance.html">Further Guidance</a></li>
<li class="toctree-l1"><a class="reference internal" href="60_conan.html">Building with Conan</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">User Guides</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../user_guide/10_overview.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../user_guide/20_tutorials.html">Tutorials</a></li>
<li class="toctree-l1"><a class="reference internal" href="../user_guide/30_configs_in_depth.html">Configs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../user_guide/40_outputs_in_depth.html">Outputs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../user_guide/50_scenario_simulation.html">Simulator</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Advanced topics</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../advanced_topics/20_simulator_advanced.html">Simulator</a></li>
<li class="toctree-l1"><a class="reference internal" href="../advanced_topics/30_testing.html">EndToEnd Test Framework</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Developer Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../developer_information/10_ide_support.html">IDE Support</a></li>
<li class="toctree-l1"><a class="reference internal" href="../developer_information/20_documentation.html">Documentation Concept</a></li>
<li class="toctree-l1"><a class="reference internal" href="../developer_information/30_coding_conventions.html">Coding Guidelines</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Other Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../other_information/10_external_dependencies.html">External Dependencies</a></li>
<li class="toctree-l1"><a class="reference internal" href="../other_information/20_glossary.html">Glossary</a></li>
<li class="toctree-l1"><a class="reference internal" href="../other_information/30_gui_plugins.html">GUI Plugins</a></li>
<li class="toctree-l1"><a class="reference internal" href="../other_information/40_license.html">License</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../index.html">openPASS</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../index.html" class="icon icon-home" aria-label="Home"></a></li>
      <li class="breadcrumb-item active">Installing Prerequisites</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../_sources/installation_guide/20_install_prerequisites.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="installing-prerequisites">
<span id="prerequisites"></span><h1>Installing Prerequisites<a class="headerlink" href="#installing-prerequisites" title="Link to this heading"></a></h1>
<p>Before being able to compile and run <strong>openPASS</strong>, make sure to have all dependencies installed.
The third party software dependency of <strong>openPASS</strong> can be divided into:</p>
<ul class="simple">
<li><p><strong>Build environment</strong>, which manages third party software and is used to compile and install <strong>openPASS</strong></p></li>
<li><p><strong>Binary packages</strong>, which can be easily installed via a package manager of the respective build environment</p></li>
<li><p><strong>Source packages</strong>, which need to be built from source code</p></li>
</ul>
<p>This section gives detailed information about the prerequisites and tested version.</p>
<section id="installing-the-build-environment">
<span id="building-under-windows"></span><h2>Installing the Build Environment<a class="headerlink" href="#installing-the-build-environment" title="Link to this heading"></a></h2>
<div class="sphinx-tabs docutils container">
<div aria-label="Tabbed content" class="closeable" role="tablist"><button aria-controls="panel-0-0-0" aria-selected="true" class="sphinx-tabs-tab" id="tab-0-0-0" name="0-0" role="tab" tabindex="0">Windows</button><button aria-controls="panel-0-0-1" aria-selected="false" class="sphinx-tabs-tab" id="tab-0-0-1" name="0-1" role="tab" tabindex="-1">Linux</button></div><div aria-labelledby="tab-0-0-0" class="sphinx-tabs-panel" id="panel-0-0-0" name="0-0" role="tabpanel" tabindex="0"><ol class="arabic">
<li><p>MSYS2</p>
<p>On Windows, the build environment of choice are <a class="reference internal" href="../other_information/20_glossary.html#term-MSYS2"><span class="xref std std-term">MSYS2</span></a> programming tools.
<a class="reference internal" href="../other_information/20_glossary.html#term-MSYS2"><span class="xref std std-term">MSYS2</span></a> is used to install some third-party software on which <strong>openPASS</strong> depends.
Also, the unix-like shell simplifies c++ compilation on Windows.
For details, see <a class="reference external" href="https://www.msys2.org/">MSYS2 website</a>.</p>
</li>
<li id="msys2"><p>Download MSYS2</p>
<p>The latest 64-bit package is located in the Installation section of <a class="reference external" href="https://www.msys2.org/">MSYS2 website</a>.</p>
</li>
<li id="msys2-installation"><p>Install MSYS2</p>
<p>Run the downloaded executable and adjust suggested settings to your needs (defaults are fine).</p>
<div class="admonition-installation-path admonition">
<p class="admonition-title">Installation Path</p>
<p>It is assumed that MSYS2 is installed in the directory <code class="docutils literal notranslate"><span class="pre">C:\op\msys64</span></code>, as our CI scripts depend on this specific path.
If you choose to install MSYS2 in a different location, please ensure that you update any related configurations to reflect the new installation path, such as the conan profiles mentioned below.”</p>
</div>
</li>
<li><p>Understand the Build Environment</p>
<p>MSYS2 provides three different environments, located in the MSYS2 installation directory:</p>
<figure class="align-center" id="fig-msys2-environments">
<img alt="MSYS2 Apps" src="../_images/msys2.png" />
</figure>
<p>MSYS2 Environments</p>
<ul class="simple">
<li><p>MSYS2 MSYS: Common environment, i.e. for package management</p></li>
<li><p>MSYS2 MinGW 32-bit: A MinGW 32-bit environment</p></li>
<li><p>MSYS2 MinGW 64-bit: A MinGW 64-bit environment</p></li>
</ul>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<div class="line-block">
<div class="line">MSYS2 MinGW 64-bit is <strong>the</strong>  <strong>openPASS</strong> development environment and will be referred to as <code class="docutils literal notranslate"><span class="pre">MinGW</span> <span class="pre">64-bit</span></code> shell.</div>
</div>
</div>
</li>
</ol>
</div><div aria-labelledby="tab-0-0-1" class="sphinx-tabs-panel" hidden="true" id="panel-0-0-1" name="0-1" role="tabpanel" tabindex="0">
<span id="building-under-linux"></span><p>On Linux, no special build environment is needed. <strong>openPASS</strong> is developed under Debian 64-Bit,
which means that developing under a recent Ubuntu distribution will also work.
Debian Bookworm or Ubuntu 22.04 LTS is recommended. Debian uses <code class="docutils literal notranslate"><span class="pre">apt</span></code> (or <code class="docutils literal notranslate"><span class="pre">apt-get</span></code>) as package managing system.
Details will be given in <a class="reference internal" href="#binary-packages"><span class="std std-ref">Installing the Binary Packages</span></a> and <a class="reference internal" href="#building-prerequisites"><span class="std std-ref">Installing the Dependencies</span></a>.</p>
</div></div>
</section>
<section id="installing-the-binary-packages">
<span id="binary-packages"></span><h2>Installing the Binary Packages<a class="headerlink" href="#installing-the-binary-packages" title="Link to this heading"></a></h2>
<p>The first set of dependencies we need to install in order to successfully compile <strong>openPASS</strong> are the binary packages. These can be installed via appropiate package manager.</p>
<div class="sphinx-tabs docutils container">
<div aria-label="Tabbed content" class="closeable" role="tablist"><button aria-controls="panel-1-1-0" aria-selected="true" class="sphinx-tabs-tab" id="tab-1-1-0" name="1-0" role="tab" tabindex="0">Windows (MSYS2)</button><button aria-controls="panel-1-1-1" aria-selected="false" class="sphinx-tabs-tab" id="tab-1-1-1" name="1-1" role="tab" tabindex="-1">Linux (Debian Bookworm)</button></div><div aria-labelledby="tab-1-1-0" class="sphinx-tabs-panel" id="panel-1-1-0" name="1-0" role="tabpanel" tabindex="0"><ol class="arabic">
<li><p>Open <code class="docutils literal notranslate"><span class="pre">MSYS2</span> <span class="pre">MinGW</span> <span class="pre">64-bit</span></code> and execute the following package manager <code class="docutils literal notranslate"><span class="pre">pacman</span></code> commands to update the package repository and upgrade system packages:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">pacman</span> <span class="o">-</span><span class="n">Syuu</span>
</pre></div>
</div>
<p>If the upgrade requires a restart of MSYS2, resume the upgrade by re-opening the shell and call:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">pacman</span> <span class="o">-</span><span class="n">Suu</span>
</pre></div>
</div>
</li>
<li><p>Required packages (can be specified in single command line if desired):</p>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>pacman<span class="w"> </span>-S<span class="w">  </span><span class="se">\</span>
<span class="w">    </span><span class="sb">`</span><span class="c1"># for building and running the simulator` \</span>
<span class="w">    </span>make<span class="w"> </span><span class="se">\</span>
<span class="w">    </span>mingw-w64-x86_64-ccache<span class="w"> </span><span class="se">\</span>
<span class="w">    </span>mingw-w64-x86_64-cmake<span class="w"> </span><span class="se">\</span>
<span class="w">    </span>mingw-w64-x86_64-doxygen<span class="w"> </span><span class="se">\</span>
<span class="w">    </span>mingw-w64-x86_64-gcc<span class="w"> </span><span class="se">\</span>
<span class="w">    </span>mingw-w64-x86_64-gdb<span class="w"> </span><span class="se">\</span>
<span class="w">    </span>mingw-w64-x86_64-graphviz<span class="w"> </span><span class="se">\</span>
<span class="w">    </span>mingw-w64-x86_64-make<span class="w"> </span><span class="se">\</span>
<span class="w">    </span>patch<span class="w"> </span><span class="se">\</span>
<span class="w">    </span><span class="sb">`</span><span class="c1"># for documentation` \</span>
<span class="w">    </span>mingw-w64-x86_64-python<span class="w"> </span><span class="se">\</span>
<span class="w">    </span>mingw-w64-x86_64-python-pip<span class="w"> </span><span class="se">\</span>
<span class="w">    </span>mingw-w64-x86_64-python-lxml<span class="w"> </span><span class="se">\</span>
<span class="w">    </span><span class="sb">`</span><span class="c1"># fonts and equation rendering in the documentation` \</span>
<span class="w">    </span>mingw-w64-x86_64-texlive-bin<span class="w"> </span><span class="se">\</span>
<span class="w">    </span>mingw-w64-x86_64-texlive-core<span class="w"> </span><span class="se">\</span>
<span class="w">    </span>mingw-w64-x86_64-texlive-font-utils<span class="w"> </span><span class="se">\</span>
<span class="w">    </span>mingw-w64-x86_64-texlive-latex-extra<span class="w"> </span><span class="se">\</span>
<span class="w">    </span>mingw-w64-x86_64-zziplib<span class="w"> </span><span class="se">\</span>
<span class="w">    </span><span class="sb">`</span><span class="c1"># documentation with only pacman` \</span>
<span class="w">    </span>libxslt-devel<span class="w"> </span><span class="se">\</span>
<span class="w">    </span>mingw-w64-x86_64-python-sphinx<span class="w"> </span><span class="se">\</span>
<span class="w">    </span>mingw-w64-x86_64-python-sphinx-tabs<span class="w"> </span><span class="se">\</span>
<span class="w">    </span>mingw-w64-x86_64-python-sphinx_rtd_theme<span class="w"> </span><span class="se">\</span>
<span class="w">    </span>mingw-w64-x86_64-python-setuptools<span class="w"> </span><span class="se">\</span>
<span class="w">    </span>mingw-w64-x86_64-python-myst-parser<span class="w"> </span><span class="se">\</span>
<span class="w">    </span><span class="sb">`</span><span class="c1"># for testing (optional)` \</span>
<span class="w">    </span>mingw-w64-x86_64-python-pytest<span class="w"> </span><span class="se">\</span>
<span class="w">    </span>mingw-w64-x86_64-python-pandas<span class="w"> </span><span class="se">\</span>
<span class="w">    </span><span class="sb">`</span><span class="c1"># for developing purposes (optional)` \</span>
<span class="w">    </span>mingw-w64-x86_64-clang
</pre></div>
</div>
<div class="admonition-versions admonition">
<p class="admonition-title">Versions</p>
<div class="line-block">
<div class="line">MSYS2 provides rolling release versions, so some packages might be too “up-to-date”.</div>
</div>
</div>
</li>
<li><p>Required python packages</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">pip3</span> <span class="n">install</span> <span class="s2">&quot;approvaltests==3.1.0&quot;</span> <span class="n">breathe</span> <span class="s2">&quot;conan&gt;2.0&quot;</span> <span class="n">empty</span><span class="o">-</span><span class="n">files</span> <span class="n">exhale</span> <span class="n">watchdog</span>
</pre></div>
</div>
</li>
</ol>
<div class="admonition-git-ssh admonition">
<p class="admonition-title">GIT/SSH</p>
<p>The <code class="docutils literal notranslate"><span class="pre">MinGW</span> <span class="pre">64-bit</span></code> shell does not access an already existing git installation or available SSH keys.
Make sure, to update/copy your configuration and credentials within the <code class="docutils literal notranslate"><span class="pre">MinGW</span> <span class="pre">64-bit</span></code> shell before working with git.</p>
</div>
</div><div aria-labelledby="tab-1-1-1" class="sphinx-tabs-panel" hidden="true" id="panel-1-1-1" name="1-1" role="tabpanel" tabindex="0"><ol class="arabic">
<li><p>Update  the package database on the system</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">apt</span> <span class="n">update</span>
</pre></div>
</div>
</li>
<li><p>Upgrade existing software to latest version</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">apt</span> <span class="n">upgrade</span>
</pre></div>
</div>
</li>
<li><p>Install required binary packages</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="c1"># for simulator</span>
<span class="n">apt</span> <span class="o">-</span><span class="n">y</span> <span class="n">install</span> <span class="n">antlr4</span>
<span class="n">apt</span> <span class="o">-</span><span class="n">y</span> <span class="n">install</span> <span class="n">build</span><span class="o">-</span><span class="n">essential</span>
<span class="n">apt</span> <span class="o">-</span><span class="n">y</span> <span class="n">install</span> <span class="n">ca</span><span class="o">-</span><span class="n">certificates</span>
<span class="n">apt</span> <span class="o">-</span><span class="n">y</span> <span class="n">install</span> <span class="n">ccache</span>
<span class="n">apt</span> <span class="o">-</span><span class="n">y</span> <span class="n">install</span> <span class="n">cmake</span>
<span class="n">apt</span> <span class="o">-</span><span class="n">y</span> <span class="n">install</span> <span class="n">clang</span><span class="o">-</span><span class="nb">format</span><span class="o">-</span><span class="mi">15</span>
<span class="n">apt</span> <span class="o">-</span><span class="n">y</span> <span class="n">install</span> <span class="n">doxygen</span>
<span class="n">apt</span> <span class="o">-</span><span class="n">y</span> <span class="n">install</span> <span class="n">g</span><span class="o">++</span>
<span class="n">apt</span> <span class="o">-</span><span class="n">y</span> <span class="n">install</span> <span class="n">gcc</span>
<span class="n">apt</span> <span class="o">-</span><span class="n">y</span> <span class="n">install</span> <span class="n">git</span>
<span class="n">apt</span> <span class="o">-</span><span class="n">y</span> <span class="n">install</span> <span class="n">googletest</span>
<span class="n">apt</span> <span class="o">-</span><span class="n">y</span> <span class="n">install</span> <span class="n">graphviz</span>
<span class="n">apt</span> <span class="o">-</span><span class="n">y</span> <span class="n">install</span> <span class="n">libboost</span><span class="o">-</span><span class="n">filesystem</span><span class="o">-</span><span class="n">dev</span>
<span class="n">apt</span> <span class="o">-</span><span class="n">y</span> <span class="n">install</span> <span class="n">libprotobuf</span><span class="o">-</span><span class="n">dev</span>
<span class="n">apt</span> <span class="o">-</span><span class="n">y</span> <span class="n">install</span> <span class="n">libantlr4</span><span class="o">-</span><span class="n">runtime4</span><span class="mf">.9</span>
<span class="n">apt</span> <span class="o">-</span><span class="n">y</span> <span class="n">install</span> <span class="n">libantlr4</span><span class="o">-</span><span class="n">runtime</span><span class="o">-</span><span class="n">java</span>
<span class="n">apt</span> <span class="o">-</span><span class="n">y</span> <span class="n">install</span> <span class="n">libantlr4</span><span class="o">-</span><span class="n">runtime</span><span class="o">-</span><span class="n">dev</span>
<span class="n">apt</span> <span class="o">-</span><span class="n">y</span> <span class="n">install</span> <span class="n">openjdk</span><span class="o">-</span><span class="mi">17</span><span class="o">-</span><span class="n">jre</span>
<span class="n">apt</span> <span class="o">-</span><span class="n">y</span> <span class="n">install</span> <span class="n">pkg</span><span class="o">-</span><span class="n">config</span>
<span class="n">apt</span> <span class="o">-</span><span class="n">y</span> <span class="n">install</span> <span class="n">protobuf</span><span class="o">-</span><span class="n">compiler</span>
<span class="n">apt</span> <span class="o">-</span><span class="n">y</span> <span class="n">install</span> <span class="n">python3</span>
<span class="n">apt</span> <span class="o">-</span><span class="n">y</span> <span class="n">install</span> <span class="n">python3</span><span class="o">-</span><span class="n">distutils</span>
<span class="n">apt</span> <span class="o">-</span><span class="n">y</span> <span class="n">install</span> <span class="n">python3</span><span class="o">-</span><span class="n">pip</span>
<span class="n">apt</span> <span class="o">-</span><span class="n">y</span> <span class="n">install</span> <span class="n">uuid</span><span class="o">-</span><span class="n">dev</span>

<span class="c1"># python packages</span>
<span class="n">pip3</span> <span class="n">install</span> <span class="s2">&quot;approvaltests==3.1.0&quot;</span> <span class="n">empty</span><span class="o">-</span><span class="n">files</span> <span class="s2">&quot;conan&gt;2.0&quot;</span> <span class="n">watchdog</span>
<span class="n">pip3</span> <span class="n">install</span> <span class="n">breathe</span> <span class="n">exhale</span> <span class="n">myst</span><span class="o">-</span><span class="n">parser</span> <span class="s2">&quot;sphinx==7.2.6&quot;</span> <span class="n">sphinx</span><span class="o">-</span><span class="n">rtd</span><span class="o">-</span><span class="n">theme</span> <span class="n">sphinx</span><span class="o">-</span><span class="n">tabs</span> <span class="n">sphinxcontrib</span><span class="o">-</span><span class="n">spelling</span>
</pre></div>
</div>
</li>
</ol>
</div></div>
<p><strong>EndToEnd Test Framework</strong></p>
<p>If end to end tests shall be executed, additional requirements have to be considered.
Please refer to <a class="reference internal" href="../advanced_topics/30_testing.html#testing-endtoend"><span class="std std-ref">EndToEnd Test Framework</span></a> for more details on installation of the prerequisites and usage of the framework.</p>
</section>
<section id="installing-the-dependencies">
<span id="building-prerequisites"></span><h2>Installing the Dependencies<a class="headerlink" href="#installing-the-dependencies" title="Link to this heading"></a></h2>
<p>This section describes how to compile prerequisites of <strong>openPASS</strong> using conan (<code class="docutils literal notranslate"><span class="pre">conan&gt;2.0</span></code>).</p>
<p>The goal of this section is to build and install necessary packages into a suitable directory using conan.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>If you are unfamiliar to <code class="docutils literal notranslate"><span class="pre">conan</span></code> or working with it, Section <a class="reference internal" href="60_conan.html#building-with-conan"><span class="std std-ref">Building with Conan</span></a> might give you a short introduction on conan in the scope of building dependencies for <strong>openPASS</strong>.</p>
</div>
<p>To keep the installation process of <strong>openPASS</strong> and its dependencies as simple as possible, we recommend a specific folder structure.
If you strictly follow the recommended paths of this guide, no command modifications are necessary.</p>
<div class="sphinx-tabs docutils container">
<div aria-label="Tabbed content" class="closeable" role="tablist"><button aria-controls="panel-2-2-0" aria-selected="true" class="sphinx-tabs-tab" id="tab-2-2-0" name="2-0" role="tab" tabindex="0">Notes for Windows</button><button aria-controls="panel-2-2-1" aria-selected="false" class="sphinx-tabs-tab" id="tab-2-2-1" name="2-1" role="tab" tabindex="-1">Notes for Linux</button></div><div aria-labelledby="tab-2-2-0" class="sphinx-tabs-panel" id="panel-2-2-0" name="2-0" role="tabpanel" tabindex="0"><ul class="simple">
<li><p>Recommended checkout path of <strong>openPASS</strong> repository: <code class="docutils literal notranslate"><span class="pre">C:\openpass</span></code></p></li>
<li><p>Dependency directory within the <strong>openPASS</strong> repository: <code class="docutils literal notranslate"><span class="pre">C:\deps</span></code></p></li>
<li><p>Recommended installation directory of <strong>openPASS</strong>: <code class="docutils literal notranslate"><span class="pre">C:\openPASS\bin\core</span></code></p></li>
</ul>
</div><div aria-labelledby="tab-2-2-1" class="sphinx-tabs-panel" hidden="true" id="panel-2-2-1" name="2-1" role="tabpanel" tabindex="0"><ul class="simple">
<li><p>Recommended checkout path of <strong>openPASS</strong> repository: <code class="docutils literal notranslate"><span class="pre">~/openpass</span></code></p></li>
<li><p>Dependency directory within the <strong>openPASS</strong> repository: <code class="docutils literal notranslate"><span class="pre">~/deps</span></code></p></li>
<li><p>Recommended installation directory of <strong>openPASS</strong>: <code class="docutils literal notranslate"><span class="pre">/usr/local/openPASS/bin/core</span></code></p></li>
</ul>
</div></div>
<p>The above directory structure will be created by following the instructions of this guide.</p>
<ol class="arabic">
<li><p>Clone <strong>openPASS</strong> repository</p>
<p>As described above, the checkout path of the repository is assumed to be the default <code class="docutils literal notranslate"><span class="pre">openpass</span></code>.</p>
<div class="sphinx-tabs docutils container">
<div aria-label="Tabbed content" class="closeable" role="tablist"><button aria-controls="panel-3-3-0" aria-selected="true" class="sphinx-tabs-tab" id="tab-3-3-0" name="3-0" role="tab" tabindex="0">Windows</button><button aria-controls="panel-3-3-1" aria-selected="false" class="sphinx-tabs-tab" id="tab-3-3-1" name="3-1" role="tab" tabindex="-1">Linux</button></div><div aria-labelledby="tab-3-3-0" class="sphinx-tabs-panel" id="panel-3-3-0" name="3-0" role="tabpanel" tabindex="0"><p>Start <code class="docutils literal notranslate"><span class="pre">MinGW</span> <span class="pre">64-bit</span></code> shell</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">cd</span> <span class="o">/</span><span class="n">C</span><span class="o">/</span>
<span class="n">git</span> <span class="n">clone</span> <span class="n">https</span><span class="p">:</span><span class="o">//</span><span class="n">gitlab</span><span class="o">.</span><span class="n">eclipse</span><span class="o">.</span><span class="n">org</span><span class="o">/</span><span class="n">eclipse</span><span class="o">/</span><span class="n">openpass</span><span class="o">/</span><span class="n">opSimulation</span><span class="o">.</span><span class="n">git</span> <span class="n">openpass</span>
</pre></div>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>As stated in <a class="reference internal" href="#building-under-windows"><span class="std std-ref">Installing the Build Environment</span></a>, the windows programming tools suffer from a <cite>path length restriction</cite>.
This error manifests as strange <strong>file not found</strong> compile errors.
It is therefore recommended to use a short path for source code checkout, e.g. a drive letter.
This can also be done by the windows command <a class="reference external" href="https://docs.microsoft.com/en-us/windows-server/administration/windows-commands/subst">subst</a>.</p>
</div>
</div><div aria-labelledby="tab-3-3-1" class="sphinx-tabs-panel" hidden="true" id="panel-3-3-1" name="3-1" role="tabpanel" tabindex="0"><p>Start <code class="docutils literal notranslate"><span class="pre">Bash</span></code> shell</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">cd</span> <span class="o">~</span>
<span class="n">git</span> <span class="n">clone</span> <span class="n">https</span><span class="p">:</span><span class="o">//</span><span class="n">gitlab</span><span class="o">.</span><span class="n">eclipse</span><span class="o">.</span><span class="n">org</span><span class="o">/</span><span class="n">eclipse</span><span class="o">/</span><span class="n">openpass</span><span class="o">/</span><span class="n">opSimulation</span><span class="o">.</span><span class="n">git</span> <span class="n">openpass</span>
</pre></div>
</div>
</div></div>
</li>
<li><p>Navigate into repository and checkout main branch</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">cd</span> <span class="n">openpass</span>
<span class="n">git</span> <span class="n">checkout</span> <span class="n">main</span>
</pre></div>
</div>
</li>
<li><p>The essential packages necessary for <strong>openPASS</strong> are listed in the file <code class="docutils literal notranslate"><span class="pre">utils/ci/conan/conanfile.txt</span></code>.</p>
<p>If a required package is available on ConanCenter, they will be used directly.
For packages not available on ConanCenter, the respective recipes are stored in the <code class="docutils literal notranslate"><span class="pre">utils/ci/conan/recipe</span></code> folder.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>It is important to have conancenter remote enabled. To check the status of conancenter and to enable, if it is disabled, execute the following commands</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">conan</span> <span class="n">remote</span> <span class="nb">list</span>
<span class="n">conan</span> <span class="n">remote</span> <span class="n">enable</span> <span class="n">conancenter</span>
</pre></div>
</div>
</div>
</li>
<li><p>There are two Conan profiles <code class="docutils literal notranslate"><span class="pre">conanprofile_linux</span></code> and <code class="docutils literal notranslate"><span class="pre">conanprofile_windows</span></code> available in the <code class="docutils literal notranslate"><span class="pre">utils/ci/conan/recipe</span></code> folder, which will be automatically used in the next step.</p>
<div class="admonition-adjustments admonition">
<p class="admonition-title">Adjustments</p>
<p>Check and adjust the compiler version and the path to the MSYS installation in these profiles before running the prepare scripts.</p>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>The recommended compiler is GCC. Usage of other compilers may lead to unexpected outcomes.</p>
</div>
</li>
<li><p>To build and install the dependencies, run the script <code class="docutils literal notranslate"><span class="pre">15_prepare_thirdParty.sh</span></code> located in <code class="docutils literal notranslate"><span class="pre">utils/ci/scripts</span></code>.</p>
<div class="sphinx-tabs docutils container">
<div aria-label="Tabbed content" class="closeable" role="tablist"><button aria-controls="panel-4-4-0" aria-selected="true" class="sphinx-tabs-tab" id="tab-4-4-0" name="4-0" role="tab" tabindex="0">Windows</button><button aria-controls="panel-4-4-1" aria-selected="false" class="sphinx-tabs-tab" id="tab-4-4-1" name="4-1" role="tab" tabindex="-1">Linux</button></div><div aria-labelledby="tab-4-4-0" class="sphinx-tabs-panel" id="panel-4-4-0" name="4-0" role="tabpanel" tabindex="0"><ol class="arabic">
<li><p>One of the dependencies of <strong>openPASS</strong> is OpenScenarioEngine which requires OpenSCENARIO API and it in turn requires JAVA executable to build.
If Java executable is not available on your machine, download the java from <a class="reference external" href="https://cdn.azul.com/zulu/bin/zulu11.50.19-ca-jdk11.0.12-win_x64.zip">here</a> and extract the zip file</p></li>
<li><p>If <code class="docutils literal notranslate"><span class="pre">C:\Downloads\zulu</span></code> is the extracted path, then add the variable JAVA_HOME to the environmental variable, and append the java executable path to the PATH environmental variable as below</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>export JAVA_HOME=/c/Downloads/zulu/
export PATH=$PATH:/c/Downloads/zulu/bin
</pre></div>
</div>
</li>
<li><p>The script <code class="docutils literal notranslate"><span class="pre">15_prepare_thirdParty.sh</span></code> also requires the variable PYTHON_EXECUTABLE set. This variable refers to the path of the python installation (For example: It could be either on native Windows or on MSYS).
If the python is installed on MSYS then set the variable with the following command.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">export</span> <span class="n">PYTHON_EXECUTABLE</span><span class="o">=</span><span class="n">python3</span>
</pre></div>
</div>
</li>
<li><p>Execute the script <code class="docutils literal notranslate"><span class="pre">15_prepare_thirdParty.sh</span></code> on MSYS</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">cd</span> <span class="n">utils</span><span class="o">/</span><span class="n">ci</span><span class="o">/</span><span class="n">scripts</span>
<span class="o">./</span><span class="mi">15</span><span class="n">_prepare_thirdParty</span><span class="o">.</span><span class="n">sh</span>
</pre></div>
</div>
</li>
</ol>
</div><div aria-labelledby="tab-4-4-1" class="sphinx-tabs-panel" hidden="true" id="panel-4-4-1" name="4-1" role="tabpanel" tabindex="0"><ol class="arabic">
<li><p>The script <code class="docutils literal notranslate"><span class="pre">15_prepare_thirdParty.sh</span></code> also requires the variable PYTHON_EXECUTABLE set. This variable refers to the path of the python installation.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">export</span> <span class="n">PYTHON_EXECUTABLE</span><span class="o">=</span><span class="n">python3</span>
</pre></div>
</div>
</li>
<li><p>Execute the script</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">cd</span> <span class="n">utils</span><span class="o">/</span><span class="n">ci</span><span class="o">/</span><span class="n">scripts</span>
<span class="o">./</span><span class="mi">15</span><span class="n">_prepare_thirdParty</span><span class="o">.</span><span class="n">sh</span>
</pre></div>
</div>
</li>
</ol>
</div></div>
</li>
<li><p>Upon successful execution of the script, the dependencies will be installed under <code class="docutils literal notranslate"><span class="pre">C:\deps</span></code> on Windows and  <code class="docutils literal notranslate"><span class="pre">~/deps</span></code> on Linux.</p></li>
</ol>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="15_system_requirements.html" class="btn btn-neutral float-left" title="System Requirements" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="30_install_openpass.html" class="btn btn-neutral float-right" title="Installing openPASS" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2025 openPASS Working Group.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>